;Mandlebrot VIC-20.
;80x160, so jump..
;So, 12.8K pixels to calculate.
;At this resolution, would 24-bit arithmetic work?
;4:12 x 4:12 => 4:12.
;How fast would that be with simple bit multiply?
;Dither algorithm too?
;Vertical strip organisation.
;graphics are 20x20 = 400b, so 112b at the end.
;Also, needed 200 characters.
;standard boundary: (-2,-1), (1,1).
;so x diff = (3<<12)/80 = 154 (153.6)
;and y diff = (2<<12)/160 = 51.2 = 52.

;HiUxLife.s
;assemble with: ./mac2c64 -r blinky.s 
;then rename to .prg.
;Memory map 2:
;$1000            $10c8       $1380        $2000
;[Basic/Video:200][MCode:696b][Chrs:200*16=3200]
;Chars start at $38, which is 896b, the max size for the image.
;Startup is now at end, is 82b long so 896+82=978b for image. 
;Mandlebrot generation is 5:49.
;   2012 SYS 4110
;
;Would a cached multiply algorithm be faster?
;Need 3b*16 = 48 + 16b, for 16 entries.
;Need to multiply result by 16:
;Can I improve it by combining the MulRes with MulA,
;Using Acc as the bottom byte; then zero-page for the next 2
;And only non-zero page for the top one? I think MUL would be 50%
;faster (2/3 time => 4 mins instead of 6mins)
;



bitmap .equ $1380
kCols .equ 20
kRows .equ 152
kBmH .equ 160
kBitmapSz .equ 3200
kBmNextRw .equ kBitmapSz-1
kBmEndCol .equ 3200-kBmH
kBmEndColDn .equ kBmEndCol+1

video	.equ $1000
colorRam .equ $9400
cassBuff .equ 828 ;to 1019 -818 = 191b. = $33c.

;BASIC is:
;SYS 4296
        .org  $1001                          
        .byte $0C $10 $DC $07 
        .byte $9E $20 $34 $32 $39 $36 
        .byte $00 $00 $00 
		; after basic start line
        ; machine code starts at $100e = #4110
VidMore ;$100e, add 10 each time, $e*10 = 140
		;
		.ds 186 ;4097+13+186 = 4296
ptr1 .equ 251
VidPos .equ 251
ptr2 .equ 253

main
	jsr startup ; setup screen
	jsr Cls ;clear screen.
MandOut
	lda #0 ;-1<<12
	sta Cy
	lda #$f0 ;-1<<4
	sta Cy+1
	lda #160
	sta vidY
	lda #<bitmap
	sta VidPos
	lda #>bitmap
	sta VidPos+1
MandOut10 ;need to subtract 154.
	lda #$66 ;0-154 ;-2<<12
	sta Cx
	lda #$df ;e0-154 ;-2<<4
	sta Cx+1
	lda #20
	sta vidX
MandOut12
	lda #4
	sta pix
MandOut14
	;Precalc next xCoord
	clc
	lda #154
	adc Cx
	sta Cx
	bcc MandOut15
	inc Cx+1

MandOut15
	asl bCach
	asl bCach
	lda #20
	sta ManLp
	jsr MandXy ;a=color
	ora bCach
	sta bCach
	;lda #$1b
	dec pix
	bne MandOut14 ;no pixel yet, so next X
	ldy #0
	sta (VidPos),y ;store pixels.
	lda VidPos
	clc
	adc #160 ;next column
	sta VidPos
	bcc MandOut16
	inc VidPos+1
MandOut16
	dec vidX
	bne MandOut12 ;reset pix and next coord.
	;inc y
	sec
	lda VidPos
	sbc #$7f ;Lo(160*20-1)
	sta VidPos
	lda VidPos+1
	sbc #$c ;Hi(160*20-1)
	sta VidPos+1
	clc
	lda #53
	adc Cy
	sta Cy
	bcc MandOut17
	inc Cy+1
MandOut17
	dec vidY
	bne MandOut10
Done
	jmp Done

gMem
MulRes
	.byte 0,0,0,0 ;32-bit result.
gMem4
MulA
	.byte 0,0
MulB
	.byte 0,0
Cx
	.byte 0,0
Cy
	.byte 0,0
tX
	.byte 0,0
tY
	.byte 0,0
x2sp
	.byte 0,0
y2sp
	.byte 0,0

;non-page 0
tmp0
	.byte 0
tmpW1
	.byte 0,0
ManLp
	.byte 20
VidX
	.byte 0
VidY
	.byte 0
bCach
	.byte 0
pix
	.byte 0

MandXy
	ldx #0
MandXy1 ;copy Cx/y to Tx/y.
	lda Cx,x
	sta tX,x
	inx
	cpx #4
	bne MandXy1
MandXy2
	ldx #tX-gMem
	jsr AbsSq ;need to save MulRes though
	ldx #x2sp-gMem
	jsr SavMulRes
	ldx #tY-gMem
	jsr AbsSq
	ldx #y2sp-gMem
	jsr SavMulRes

	clc
	lda x2sp
	adc y2sp
	lda x2sp+1
	adc y2sp+1
	and #$c0 ;>=16K?
	bne MandXy5 ;done.
	; now save mul sign.
	lda tX+1
	eor tY+1
	sta tmp0 ; or maybe pha
MandXy3
	ldx #tX-MulRes
	jsr Abs
	ldx #tY-MulRes
	jsr Abs
	ldx #tX-gMem
	ldy #tY-gMem
	jsr MulWL ;result in gMem+2.
	;Need to correct sign now.
	lda tmp0 ;negative?
	bpl MandXy4
	sec
	lda #0
	sbc MuLRes+2
	sta MulRes+2
	lda #0
	sbc MulRes+3
	sta MulRes+3 ;negated
MandXy4
	asl MuLRes+2
	rol MuLRes+3 ;tx*=2.
	clc
	lda MuLRes+2
	adc Cy
	sta tY
	lda MuLRes+3
	adc Cy+1
	sta tY+1 ;y=2x+cy
	sec
	lda x2sp
	sbc y2sp
	sta x2sp
	lda x2sp+1
	sbc y2sp+1
	sta x2sp+1
	clc
	lda x2sp
	adc Cx
	sta Tx
	lda x2sp+1
	adc Cx+1
	sta Tx+1
	dec ManLp
	beq MandXy5
	jmp MandXy2
	;Black!
MandXy5 ;escape! MOD 3 to get colour?
	ldx ManLp
	lda Mod3,X
	rts
	
	
Mod3
	.byte 0, 1, 2, 3, 1, 2, 3, 1, 2, 3
	.byte 1, 2, 3, 1, 2, 3, 1, 2, 3, 1, 2
	

;Does Abs in place, based on the parameter defined by x.
Abs
	lda MulRes+1,x
	bpl Abs10
	sec
	lda #0
	sbc MulRes,x
	sta MulRes,x ;inverting
	lda #0
	sbc MulRes+1,x
	sta MulRes+1,x ;copy and abs.
Abs10
	rts

SavMulRes ;MulRes[3]:MulRes[2] => gMem,X
	lda MulRes+2
	sta gMem,x
	lda MulRes+3
	sta gMem+1,x
	rts

AbsSq ;moves tX/tY to x2sp / y2sp.
	lda gMem,x
	sta gMem4,x
	lda gMem+1,x
	bpl AbsSq10
	sec
	lda #0
	sbc gMem4,x
	sta gMem4,x ;neg low dst byte.
	lda #0
	sbc gMem+1,x ;
AbsSq10
	sta gMem4+1,x ;copy and abs.
	inx
	inx
	inx
	inx ;x^x2sp / y2sp.
	txa
	tay ;so does y now.

;Unsigned: 4:12 x 4:12 => 8:24.
;So, if we shift <<=4, the top 16-bits are 4:12
;again.
MulWL ;x^a, y^b
	lda gMem,x
	sta MulA
	lda gMem+1,x
	sta MulA+1
	lda gMem,y
	sta MulB
	lda gMem+1,y
	sta MulB+1 ;maybe turn into loop?
	lda #0
	sta MulRes+0
	sta MulRes+1 ;clear lower word.
	ldx #16
MulWL10
	asl MulRes
	rol MulRes+1
	rol MulRes+2
	rol MulRes+3;
	asl MulA
	rol MulA+1
	bcc MulWL20 ;33c cc case. vs 17c.
	clc
	lda MulB
	adc MulRes
	sta MulRes
	lda MulB+1
	adc MulRes+1
	sta MulRes+1
	bcc MulWL20 ;23c.
	inc MulRes+2
	bne MulWL20 ;+7 (50%)
	inc MulRes+3 ; +4 (1%)
MulWL20
	dex
	bne MulWL10 ;5c = 38c*16+(23c+3.5)*0.5*16 = 820c = 820us
	ldx #4
MulWL30
	asl MulRes+1
	rol MulRes+2
	rol MulRes+3
	dex
	bne MulWL30 ;920us? About 1ms.
	rts
;1ms*3 multiplies per loop = 3ms.
;So 3*80 = 240ms / scan, so maybe 1s per scan on average?
;160s total.

;**
; Setup screen and clear it.
; The screen consists of 20 columns x 10 rows of double-height characters.
; The screen starts at $1000 and ends 400 bytes later at $118F.
; The character set used are the last 200 characters, $38 to $FF, i.e.
; character 56 to 255. Once it's written we no longer need to change it.
;
; ColorRam is at $9400 and is filled with 0s, so ink is black.
; Multicolour mode is set by setting bit 3.
; Bitmap defines colors:
;		00=Screen(36879<7:4>), 01=border(36879<2:0>),
;		10=Char, 11=aux(36878)
; Normally, 36879<3>=0 means Char colors are paper and screen=ink:
; Black, white, red, cyan, magenta, green, blue, yellow,
; I want Paper=black, border=white, ink=red, aux=green.
; Orange, buff, pink, cyan, purple, bluey-green, dark purple, light yellow.
;**
startup ;82b long.
	lda #20 ;bit9 of addr=0, 20 columns, colorRam at $9400.
	sta 36866 ;A9:columns
	lda #128+20+1 ;frame1,2*rows,double-height.
	sta 36867 ;rows
	lda #$f ;border=yellow, paper=black.
	sta 36879
	lda #$66 ;green aux.
	sta 36878
	
	;clear screen.
	ldy #0 ;column
	ldx #0; offset.
	lda #$38
	sta tmp0
	
startup10
	lda tmp0
	sta video,x
	lda #8+2 ;multicolor, red ink.
	sta colorRam,x
	inc tmp0 ;next char
	txa
	clc
	adc #20
	tax ;displacement is next row
	cmp #200 ;acc+ -200
	bcc startup10
	sec
	sbc #199 ;next column on first row.
	tax
	iny
	cpy #20
	bne startup10
	;jmp stop

	lda #$cc ;chrset at block 0 [low ram]+A12=$1000.
	sta 36869	;video ram and char set at $1000.
	rts
	
	;now fill in the bitmap area: clear screen.
Cls
	lda #0
	sta ptr1
	lda #>bitmap ;clear the generation string too.
	sta ptr1+1 ;aligned by page.
	ldy #<bitmap ;offset within page.
	
	;Clear screen bitmap.
startup20
	;lda #85 ;border=white.
	tya
	sta (ptr1),y ;store in bitmap
	iny
	bne startup30
	inc ptr1+1 ;inc page.
startup30
	lda ptr1+1
	cmp #$20 ;end of char set yet?
	bne startup20 ;next page.
	rts
startupDone





gCharSet
	